package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	INFO            = "info"
	TYPE            = "type"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_GROUP_ROLE = "user_group_role"
	GROUP_UID       = "group_uid"
	GROUP_NAME      = "group_name"
	GROUP_TYPE      = "group_type"
	ACTIVITY_UID    = "activity_uid"
)

type UserGroup struct {
	db.ModelUserPlace
	GroupUID string `gorm:"type:char(32);index"`
}
type Group struct {
	db.ModelPlace
	CompanyUID string `gorm:"type:char(32);index"`
}
type Activity struct {
	db.ModelContent
	GroupUID string `gorm:"type:char(32);index"`
}

func init() { db.CmdModels("", &UserGroup{}, &Group{}, &Activity{}) }
