package tke

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/renzhengshouquan"
	"shylinux.com/x/community/src/renzhengshouquan/external/tencentcloud"

	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common"
	sdk "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/tke/v20180525"
)

type tke struct {
	renzhengshouquan.Tables
	tencentcloud.Tencentcloud
	order string `data:"17"`
	list  string `name:"list auth_uid uid auto" help:"容器服务" role:"worker"`
}

func (s tke) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		request := sdk.NewDescribeClustersRequest()
		response, err := s.newClient(m).DescribeClusters(request)
		s.ParseResponseList(m, response, err, "Response.Clusters")
		m.RenameAppend("ClusterId", "uid")
	} else {
		request := sdk.NewDescribeClusterInstancesRequest()
		request.ClusterId = common.StringPtr(arg[1])
		response, err := s.newClient(m).DescribeClusterInstances(request)
		s.ParseResponseList(m, response, err, "Response.InstanceSet")
		m.RenameAppend("ClusterId", "uid")
	}
	m.Display("")
}

func init() { ice.TeamCtxCmd(tke{}) }

func (s tke) newClient(m *ice.Message, arg ...string) *sdk.Client {
	c, _ := sdk.NewClient(s.NewCredential(m), "ap-guangzhou", s.NewProfile(m))
	return c
}
